---
- name: This sets up a Docker server
  hosts: testvm-dev
  remote_user: ec2-user
  become: true
  become_method: sudo
  vars:
      vol: /tmp/myefs/docker_volume/
      image: "{{ lookup('env', 'IMAGE') }}"

  tasks:
  - name: set fact here
    set_fact:
      random_number: "{{ 100 | random }}"
    run_once: yes
  - name: Installing Docker
    yum:
      name: docker
      state: present
  - name: Installing Git
    yum:
      name: git
      state: present
  - name: Start Docker Service
    service:
      name: docker
      state: started
  - name: Enable Docker Service
    service:
      name: docker
      enabled: yes
  - name: Creating a DIR for Dockefile snippet
    file:
      path: mysnippet{{ random_number }}
      state: directory
      mode: "u=rwx,g=rx,o=rx"
  - name: Pulling Dockerfile as a snippet
    args:
      chdir: mysnippet{{ random_number }}
    shell: git clone https://gitlab.com/snippets/2041720.git
    register: shell_result
  - debug:
      var: shell_result
  - name: Build Docker Image
    args:
      chdir: mysnippet{{ random_number }}/2041720
    shell: docker build -t {{ image }} .
    register: shell_result
  - debug:
      var: shell_result
  - name: Creating test container
    command: "{{ item }}"
    with_items:
    - docker run -itd  --name=test_machine320"{{ random_number }}" centos
    - docker run -itd --name=webserver320"{{ random_number }}" -p 320"{{ random_number }}":80 -v "{{ vol }}":/var/www/html/  myweb:v1.0
    register: shell_result
  - debug:
      var: shell_result
  - name: Testing
    shell: host myip.opendns.com resolver1.opendns.com | grep address |  awk '{print $4}'
    register: shell_result
  - debug:
      msg: Testing URL is http://{{ shell_result.stdout }}:320{{ random_number }}/webapp/index_dev.jsp
